##
from model import Oral
import re

##
Finding = """
一带黏膜组织5*4*3cm，切面见一溃疡性肿块2.5*1.5*0.5cm，灰白界不清（1）
送检切缘：前、后、左、右、底、舌N、左舌、舌腹、右舌肌、下颌舌骨肌均0.5cm
另送：
左颈大块9*6*4cm，一侧见一腺体4*3*2cm，灰黄分叶，余为脂肪血管。
I区： 3只直径1-1.5cm。
II区： 4只直径0.5-1.5cm。
III区： 12只直径0.4-1cm。
"""
Conclusion = """
“左口底”黏膜鳞状细胞癌，高-中分化，DOI≤5mm
送检切缘：“前、后、左、右、底、舌N、左舌、舌腹、右舌肌、下颌舌骨肌”均阴性（-）
“左颌下腺”轻度慢性炎
送检淋巴结：“左”“I”3只，“II”4只，“III”12只均阴性（-）
北院分子结果(NM2021-0492)：EGFR扩增探针 FISH（-）
北院免疫组化结果(NI2021-1029)：
AE1/AE3+ CKH+ CK5/6+ EGFR部分+ Ki67部分+ CD31- S-100- P16-
"""

oral = Oral(Finding, Conclusion, verbose = False)


##
def get_color(text, entity_list, replaced_word, ImmunohistochemistryContent, MolecularResultsContent):
    # print('replaced_word:', replaced_word)
    # print(ImmunohistochemistryContent)
    # print(MolecularResultsContent)
    synonyms = []
    for item in entity_list:
        if item['tag'] == 'ANATOMY':
            words_anatomy = item['words']
            if item['words'] == 'I' or item['words'] == 'II' or item['words'] == 'III' or item['words'] == 'IV' or item[
                'words'] == 'VI' or item['words'] == 'V' or item['words'] == '右' or item['words'] == '左':
                words_anatomy = "“" + item['words'] + "”"
            for i in re.finditer(
                    words_anatomy.replace('*', '\*').replace('(', '\(').replace(')', '\)').replace('+', '\+'), text):
                synonyms.append(i.span())
        if item['tag'] == 'OTHER':
            for i in re.finditer(
                    item['words'].replace('*', '\*').replace('(', '\(').replace(')', '\)').replace('+', '\+'), text):
                synonyms.append(i.span())
    
    negative = []
    for i in re.finditer('无', text):
        negative.append(i.span())
    for i in re.finditer('未见', text):
        negative.append(i.span())
    for i in re.finditer('未发生', text):
        negative.append(i.span())
    
    numeracal = []
    for item in entity_list:
        if item['tag'] == 'NUMBER':
            for i in re.finditer(
                    item['words'].replace('*', '\*').replace('(', '\(').replace(')', '\)').replace('+', '\+'), text):
                numeracal.append(i.span())
        if item['tag'] == 'SIZE':
            # if item['words']=='12*9*8cm':
            #     print("^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^")
            #     print(text)
            #     for i in re.finditer(item['words'], text):
            #         print(i)
            #     print("^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^")
            
            for i in re.finditer(
                    item['words'].replace('*', '\*').replace('(', '\(').replace(')', '\)').replace('+', '\+'), text):
                numeracal.append(i.span())
        if item['tag'] == 'DOI':
            if replaced_word == '':
                for i in re.finditer(
                        item['words'].replace('*', '\*').replace('(', '\(').replace(')', '\)').replace('+', '\+'),
                        text):
                    numeracal.append(i.span())
            else:
                if item['words'] not in text:
                    if replaced_word == '大于':
                        doi_words = item['words'].replace(">", "大于")
                    elif replaced_word == '小于':
                        doi_words = item['words'].replace("<", "小于")
                    elif replaced_word == '大于等于':
                        doi_words = item['words'].replace("≥", "大于等于")
                    elif replaced_word == '小于等于':
                        doi_words = item['words'].replace("≤", "小于等于")
                    elif replaced_word == '＞':
                        doi_words = item['words'].replace(">", "＞")
                    elif replaced_word == '小于':
                        doi_words = item['words'].replace("<", "＜")
                    for i in re.finditer(
                            doi_words.replace('*', '\*').replace('(', '\(').replace(')', '\)').replace('+', '\+'),
                            text):
                        numeracal.append(i.span())
    
    summary = []
    for item in entity_list:
        if item['tag'] == 'ENE':
            for i in re.finditer(
                    item['words'].replace('*', '\*').replace('(', '\(').replace(')', '\)').replace('+', '\+'), text):
                summary.append(i.span())
        if item['tag'] == 'PN':
            for i in re.finditer(
                    item['words'].replace('*', '\*').replace('(', '\(').replace(')', '\)').replace('+', '\+'), text):
                summary.append(i.span())
    
    classification = []
    for item in entity_list:
        if item['tag'] == 'LEVEL':
            for i in re.finditer(
                    item['words'].replace('*', '\*').replace('(', '\(').replace(')', '\)').replace('+', '\+'), text):
                classification.append(i.span())
    
    other = []
    for item in entity_list:
        if item['tag'] == 'SQUAMOUS':
            for i in re.finditer(
                    item['words'].replace('*', '\*').replace('(', '\(').replace(')', '\)').replace('+', '\+'), text):
                other.append(i.span())
        if item['tag'] == 'INVASION':
            for i in re.finditer(
                    item['words'].replace('*', '\*').replace('(', '\(').replace(')', '\)').replace('+', '\+'), text):
                other.append(i.span())
    if ImmunohistochemistryContent != '':
        for i in re.split('。| |\n', ImmunohistochemistryContent):
            # print(i)
            if i == "" or i == "\n":
                continue
            for j in re.finditer(i, text):
                # print(j)
                other.append(j.span())
    if MolecularResultsContent != '':
        for i in re.split('。| |\n', MolecularResultsContent):
            # print(i)
            if i == "" or i == "\n":
                continue
            for j in re.finditer(i, text):
                # print(j)
                other.append(j.span())
    
    synonyms = sorted(list(set(synonyms)))
    negative = sorted(list(set(negative)))
    numeracal = sorted(list(set(numeracal)))
    summary = sorted(list(set(summary)))
    classification = sorted(list(set(classification)))
    other = sorted(list(set(other)))
    
    # print("*****************")
    remove_dumplicate(other)
    remove_dumplicate(synonyms)
    remove_dumplicate(negative)
    remove_dumplicate(numeracal)
    remove_dumplicate(summary)
    remove_dumplicate(classification)
    # print("*****************")
    
    return {
        '医学术语解析': other,
        '同义词判断': synonyms,
        '否定修饰解析': negative,
        '数值解析': numeracal,
        '归纳解析': summary,
        '分类变量解析': classification
    }


def remove_dumplicate(l):
    for i in range(len(l) - 1):
        if l[i + 1][0] < l[i][1]:
            l.pop(i + 1)
    


##
if __name__ == '__main__':
    
    finding_list, conclusion_list, findind_replaced_word, conclusion_replaced_word, ImmunohistochemistryContent, MolecularResultsContent = oral.get_entity()
    
    for i in finding_list:
        print(i)
    r1 = get_color(Finding, finding_list, findind_replaced_word, ImmunohistochemistryContent, MolecularResultsContent)
    print("\n医学术语解析:")
    for i in r1['医学术语解析']:
        print(Finding[i[0]: i[1]], i[0], i[1])
    print("\n同义词判断:")
    for i in r1['同义词判断']:
        print(Finding[i[0]: i[1]], i[0], i[1])
    print("\n否定修饰解析:")
    for i in r1['否定修饰解析']:
        print(Finding[i[0]: i[1]], i[0], i[1])
    print("\n数值解析:")
    for i in r1['数值解析']:
        print(Finding[i[0]: i[1]], i[0], i[1])
    print("\n归纳解析:")
    for i in r1['归纳解析']:
        print(Finding[i[0]: i[1]], i[0], i[1])
    print("\n分类变量解析:")
    for i in r1['分类变量解析']:
        print(Finding[i[0]: i[1]], i[0], i[1])
    
    print("\n*****************************************\n")
    
    for i in conclusion_list:
        print(i)
    r2 = get_color(Conclusion, conclusion_list, conclusion_replaced_word, ImmunohistochemistryContent,
                   MolecularResultsContent)
    print("\n医学术语解析:")
    for i in r2['医学术语解析']:
        print(Conclusion[i[0]: i[1]], i[0], i[1])
    print("\n同义词判断:")
    for i in r2['同义词判断']:
        print(Conclusion[i[0]: i[1]], i[0], i[1], )
    print("\n否定修饰解析:")
    for i in r2['否定修饰解析']:
        print(Conclusion[i[0]: i[1]], i[0], i[1])
    print("\n数值解析:")
    for i in r2['数值解析']:
        print(Conclusion[i[0]: i[1]], i[0], i[1])
    print("\n归纳解析:")
    for i in r2['归纳解析']:
        print(Conclusion[i[0]: i[1]], i[0], i[1])
    print("\n分类变量解析:")
    for i in r2['分类变量解析']:
        print(Conclusion[i[0]: i[1]], i[0], i[1])

# ##
# print(Conclusion[235:236])
# print(Conclusion[179:180])
# print(Conclusion[161:162])
